﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.IO;
using System.Text;

namespace FOSSIL__GEN_
{
    public class Sparkline
    {
        public List<double> data { get; set; }
        public double totalChange { get; set; }

    }

    public class LowConfidenceSparkline
    {
        public List<double> data { get; set; }
        public double totalChange { get; set; }

    }

    public class ExplicitModifier
    {
        public string text { get; set; }
        public bool optional { get; set; }

    }

    public class Line
    {
        public int id { get; set; }
        public string name { get; set; }
        public string icon { get; set; }
        public int mapTier { get; set; }
        public int levelRequired { get; set; }
        public object baseType { get; set; }
        public int stackSize { get; set; }
        public object variant { get; set; }
        public object prophecyText { get; set; }
        public object artFilename { get; set; }
        public int links { get; set; }
        public int itemClass { get; set; }
        public Sparkline sparkline { get; set; }
        public LowConfidenceSparkline lowConfidenceSparkline { get; set; }
        public List<object> implicitModifiers { get; set; }
        public List<ExplicitModifier> explicitModifiers { get; set; }
        public string flavourText { get; set; }
        public bool corrupted { get; set; }
        public int gemLevel { get; set; }
        public int gemQuality { get; set; }
        public string itemType { get; set; }
        public double chaosValue { get; set; }
        public double exaltedValue { get; set; }
        public int count { get; set; }
        public string detailsId { get; set; }
        public object tradeInfo { get; set; }
        public object mapRegion { get; set; }

    }

    public class Translations
    {

    }

    public class Language
    {
        public string name { get; set; }
        public Translations translations { get; set; }

    }

    public class RootFossil
    {
        public List<Line> lines { get; set; }
        public Language language { get; set; }

    }

    public class fossil
    {
        private static string iB;

        public static void Gen(string section, string api, string league, int minValue)
        {
            List<string> itemBase = new List<string>();

            var RootFossil = JsonConvert.DeserializeObject<List<RootFossil>>(File.ReadAllText("data/ninja.fossil.json", Encoding.UTF8));

            foreach (var ln in RootFossil)
            {
                // Check if the item value is equal or superior to the minimum value

                foreach (var r in ln.lines)
                {
                    if (r.chaosValue >= 10)
                    {
                        if (!itemBase.Contains(r.name))
                        {
                            itemBase.Add(r.name);
                            iB = iB + string.Format(@" ""{0}""", r.name);
                        }
                    }
                }
            }

            if (iB == null) { iB = @""""""; }
            string fn = @"gen\" + section + ".filter";
            File.AppendAllText(fn, string.Format("# Section: {0}", section) + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, @"    Class ""Stackable Currency""" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    BaseType" + iB + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetTextColor 255 165 0 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBackgroundColor 255 255 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBorderColor 255 165 0 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetFontSize 40" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, @"    CustomAlertSound ""mx_fossil.mp3""", Encoding.UTF8);
        }
    }
}
